/***********/
/* kana2p6 */
/***********/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXLEN	1024

int str2p6(unsigned char *, unsigned char *);

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	unsigned char instr[MAXLEN];
	unsigned char p6str[MAXLEN];

	if (argc != 3) {
		fprintf(stderr, "Usage: kana2p6 infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "r")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "w")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	while ( fgets(instr, MAXLEN, infp) != NULL) {
		str2p6(p6str, instr);
		fprintf(outfp, "%s", p6str);
	}

	fclose(outfp);
	fclose(infp);

	return(0);
}

int str2p6(unsigned char *dist, unsigned char *src)
{
	unsigned char marktbl[] = {
		0x20,0xA4,0xA1,0x2C,0x2E,0xA5,0x3A,0x3B,	// 0x8140` @ABCDEFG
		0x3F,0x21,0xDE,0xDF,0x27,0x27,0x00,0x5E,	// 0x8148` HIJKLMNO
		0x7E,0x5F,0x00,0x00,0x00,0x00,0x00,0x00,	// 0x8150` PQRSTUVW
		0x00,0x00,0x00,0xB0,0xB0,0x2D,0x2F,0x5C,	// 0x8158` XYZ[\]^_
		0x7E,0x00,0x7C,0x00,0x00,0x27,0x27,0x22,	// 0x8160` `abcdefg
		0x22,0x28,0x29,0x5B,0x5D,0x5B,0x5D,0x7B,	// 0x8168` hijklmno
		0x7D,0x3C,0x3E,0x3C,0x3E,0xA2,0xA3,0xA2,	// 0x8170` pqrstuvw
		0xA3,0x5B,0x5D,0x2B,0x2D,0x00,0x2A,0x00,	// 0x8178` xyz{|}~
		0x2F,0x3D,0x00,0x3C,0x3E,0x00,0x00,0x00,	// 0x8180` 
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x5C,	// 0x8188` 
		0x24,0x00,0x00,0x25,0x23,0x26,0x2A,0x40,	// 0x8190` 
		0x00,0x82,0x82,0x84,0x85,0x00,0x83,0x83,	// 0x8198` 
		0x00,0x00,0x80,0x80,0x81,0x81,0x00,0x00,	// 0x81a0` 
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00		// 0x81a8` 
	};

	unsigned char kanatbl[] = {
													// Ђ炪ȁF0x829f`0x82f1
													// J^JiF0x8340`0x8396
		0x87,0x00,0x91,0x00,0x88,0x00,0x92,0x00,	// 
		0x89,0x00,0x93,0x00,0x8A,0x00,0x94,0x00,	// 
		0x8B,0x00,0x95,0x00,						// 
		0x96,0x00,0x96,0xDE,0x97,0x00,0x97,0xDE,	// 
		0x98,0x00,0x98,0xDE,0x99,0x00,0x99,0xDE,	// 
		0x9A,0x00,0x9A,0xDE,						// 
		0x9B,0x00,0x9B,0xDE,0x9C,0x00,0x9C,0xDE,	// 
		0x9D,0x00,0x9D,0xDE,0x9E,0x00,0x9E,0xDE,	// 
		0x9F,0x00,0x9F,0xDE,						// 
		0xE0,0x00,0xE0,0xDE,0xE1,0x00,0xE1,0xDE,	// 
		0x8F,0x00,									// 
		0xE2,0x00,0xE2,0xDE,0xE3,0x00,0xE3,0xDE,	// ÂĂ
		0xE4,0x00,0xE4,0xDE,						// Ƃ
		0xE5,0x00,0xE6,0x00,0xE7,0x00,0xE8,0x00,	// Ȃɂʂ
		0xE9,0x00,									// 
		0xEA,0x00,0xEA,0xDE,0xEA,0xDF,				// ͂΂
		0xEB,0x00,0xEB,0xDE,0xEB,0xDF,				// Ђт
		0xEC,0x00,0xEC,0xDE,0xEC,0xDF,				// ӂԂ
		0xED,0x00,0xED,0xDE,0xED,0xDF,				// ւׂ
		0xEE,0x00,0xEE,0xDE,0xEE,0xDF,				// قڂ
		0xEF,0x00,0xF0,0x00,0xF1,0x00,0xF2,0x00,	// ܂݂ނ
		0xF3,0x00,									// 
		0x8C,0x00,0xF4,0x00,0x8D,0x00,0xF5,0x00,	// 
		0x8E,0x00,0xF6,0x00,						// 
		0xF7,0x00,0xF8,0x00,0xF9,0x00,0xFA,0x00,	// 
		0xFB,0x00,									// 
		0x00,0x00,0xFC,0x00,0x00,0x00,0x00,0x00,	// 
		0x86,0x00,0xFD,0x00,0x93,0xDE,				// 
		0x00,0x00,0x00,0x00							// 
	};

	unsigned char dt1,dt2;
	unsigned char *dist_o;

	dist_o = dist;

	for (;;) {
		if (0x00 == *src) {
			*dist = '\0';
			dist ++;
			break;
		} else if (0x0d == *src || 0x0a == *src) {
			*dist = *src;
			dist ++;
			src ++;
		} else if ( (0x20 <= *src && *src < 0x7f) ||
			 (0xa1 <= *src && *src < 0xdf) ) {
			*dist = *src;
			dist ++;
			src ++;

		} else if (0x81 == *src) {	// L
			src ++;
			if (0x40 <= *src && *src < 0xb0) {
				dt1 = marktbl[*src-0x40];
				if (dt1 == 0x00) {
					dt1 = ' ';
				}
				*dist = dt1;
				dist ++;
				src ++;
			} else {
				*dist = ' ';
				dist ++;
				src ++;
			}

		} else if (0x82 == *src) {	// pAЂ炪
			src ++;
			if (0x4f <= *src && *src < 0x59) {
				*dist = *src-0x4f+'0';
				dist ++;
				src ++;
			} else if (0x60 <= *src && *src < 0x7a) {
				*dist = *src-0x60+'A';
				dist ++;
				src ++;
			} else if (0x81 <= *src && *src < 0x9b) {
				*dist = *src-0x81+'a';
				dist ++;
				src ++;
			} else if (0x9f <= *src && *src < 0xf2) {
				dt1 = kanatbl[(*src-0x9f)*2+0];
				dt2 = kanatbl[(*src-0x9f)*2+1];
				if (dt1 == 0x00) {
					*dist = ' ';
					dist ++;
					src ++;
				} else if (dt2 == 0x00) {
					*dist = dt1;
					dist ++;
					src ++;
				} else {
					*dist = dt1;
					dist ++;
					*dist = dt2;
					dist ++;
					src ++;
				}
			} else {
				*dist = ' ';
				dist ++;
				src ++;
			}

		} else if (0x83 == *src) {	// J^Ji
			src ++;
			if (0x40 <= *src && *src < 0x97) {
				if (0x80 <= *src && *src < 0x97) {
					dt1 = kanatbl[(*src-0x40-1)*2+0];
					dt2 = kanatbl[(*src-0x40-1)*2+1];
				} else {
					dt1 = kanatbl[(*src-0x40)*2+0];
					dt2 = kanatbl[(*src-0x40)*2+1];
				}
				if (dt1 == 0x00) {
					*dist = ' ';
					dist ++;
					src ++;
				} else if (dt2 == 0x00) {
					*dist = (dt1 ^ 0x20);
					dist ++;
					src ++;
				} else {
					*dist = (dt1 ^ 0x20);
					dist ++;
					*dist = dt2;
					dist ++;
					src ++;
				}
			} else {
				*dist = ' ';
				dist ++;
				src ++;
			}

		} else {
			*dist = ' ';
			dist ++;
			src ++;
		}
	}

	return dist - dist_o;
}

